// DemoGetFolderResolve.cpp : Defines the entry point for the console application.
//



#include <iostream>
using namespace std;

#include <COMUtils.h>
#include <shobjidl.h>
#include <shlobj.h>
#include <Knownfolders.h>

void ListFolders(GUID libid)
{
	HRESULT hr;
	SmartCOMPtr<IShellLibrary> library;
	SmartCOMPtr<IObjectArray> ioarr;

	hr = ::SHLoadLibraryFromKnownFolder(
		libid,
		STGM_READ,
		IID_IShellLibrary,
		reinterpret_cast<void**>(&library));
	COMHelper::TestOk(hr);

	hr = library->GetFolders(LFF_ALLITEMS,
		IID_IObjectArray,
		reinterpret_cast<void**>(&ioarr));

	if(hr == S_OK)
		cout << "Tous les repertoires sont obtenus" << endl;
	if(hr == S_FALSE)
		cout << "Des repertoires ne seront pas listes" << endl;
	if(hr != S_OK && hr != S_FALSE)
		COMHelper::TestOk(hr);

	UINT count;
	hr = ioarr->GetCount(&count);
	COMHelper::TestOk(hr);
	for(UINT i=0; i<count; i++)
	{
		SmartCOMPtr<IShellItem> item;
		SmartCOMPtr<IShellItem> resolved;
		WCHAR *nom;
		hr = ioarr->GetAt(i, IID_IShellItem,
			reinterpret_cast<void**>(&item));
		COMHelper::TestOk(hr);
		hr = item->GetDisplayName(SIGDN_NORMALDISPLAY , &nom);
		COMHelper::TestOk(hr);
		wcout << nom << " -> ";
		::CoTaskMemFree(nom);
	
		hr = library->ResolveFolder(&(*item),
			1000,
			IID_IShellItem,
			reinterpret_cast<void**>(&resolved));	
		if(hr != S_OK && hr != S_FALSE)
		{
			cout << endl;
			continue;
		}
		hr = resolved->GetDisplayName(SIGDN_FILESYSPATH, &nom);
		COMHelper::TestOk(hr);
		wcout << nom << endl;
		::CoTaskMemFree(nom);	
	}
}


int main(int argc, char* argv[])
{
	try
	{
		COMInitializer ci;
		ListFolders(FOLDERID_PicturesLibrary);
	}
	catch(COMException ce)
	{
		std::cout << ce.raison() << std::endl;
		return EXIT_FAILURE;
	}
	return EXIT_SUCCESS;
}
