// Cette dmo ets un prtexte 
//
// - prsenter les nouveux rpertories des librairies
// - indiquer comme compiler une application avec les nouvelles API
// - utiliser la SDK Windows 7, les en-ttes, les .lib, etc (configurer dans le soptions gnrales de Visual
// - travailler avec les pointeurs intelligents
// Comment trouver le CLSID, soit dans les en-ttes, soit ailleurs, mais pour l'instant on ne sait pas o
// pourquoi pas dans la base de registre

// Notes:
// CLSID_FileDialog2 n'existe pas.
// On obtient un pointeur sur elle avec une ouverture de FileOpenDialog ou FileSaveDialog
// DemoIFileDialog2.cpp : Defines the entry point for the console application.
//
// CLSCTX_INPROC_SERVER fonctionne, mais pas CLSCTX_LOCAL_SERVER


#include <iostream>

using namespace std;

#include <COMUtils.h>
#include <shobjidl.h>
#include <shlobj.h> // pour KF_FLAG_DEFAULT_PATH
#include <Knownfolders.h> // Pour les rpertoires de librairie prdfinis


void SetFolders(SmartCOMPtr<IFileDialog2> fd)
{
	GUID folders[] =
	{
		FOLDERID_DocumentsLibrary,
		FOLDERID_PicturesLibrary,
		FOLDERID_MusicLibrary,
		FOLDERID_RecordedTVLibrary,
		FOLDERID_VideosLibrary
	};
	

	int nb = sizeof(folders)/sizeof(GUID);
	for(int i=0; i<nb; i++)
	{
		HRESULT hr;
		WCHAR *nom_fichier;
		SmartCOMPtr<IShellItem> item;
		SmartCOMPtr<IShellItem> result;
		// SHGetKnownFolderItem est une nouvelle fonction Windows 7
		hr = ::SHGetKnownFolderItem(folders[i],
			KF_FLAG_DEFAULT_PATH, 
			0,
			IID_IShellItem,
			reinterpret_cast<void **>(&item));
		COMHelper::TestOk(hr);

		hr = fd->SetFolder(&(*item));
		COMHelper::TestOk(hr);
		hr = fd->Show(0);
		if(hr == S_OK)
		{
			hr = fd->GetResult(&result);
			COMHelper::TestOk(hr);
			hr = result->GetDisplayName(SIGDN_NORMALDISPLAY , &nom_fichier);
			COMHelper::TestOk(hr);
			wcout << "Selection: " << nom_fichier << endl;
			::CoTaskMemFree(nom_fichier);
		}
	}
}

int main(int argc, char* argv[])
{
	try
	{
		COMInitializer ci;
		HRESULT hr;
		SmartCOMPtr<IFileDialog2> fd;

		// Crer une instance COM de IFileDialog2
		hr = ::CoCreateInstance(CLSID_FileOpenDialog,
                          NULL,
                          CLSCTX_INPROC_SERVER,
                          IID_IFileDialog2,
                          (void **)&fd);
		COMHelper::TestOk(hr);
		SetFolders(fd);

	}
	catch(COMException ce)
	{
		std::cout << ce.raison() << std::endl;
		return EXIT_FAILURE;
	}
	return EXIT_SUCCESS;
}
