// DemoNavigationRoot.cpp : Defines the entry point for the console application.
//
#include <iostream>
using namespace std;

#include <COMUtils.h>
#include <shobjidl.h>
#include <shlobj.h>
#include <Knownfolders.h>

int main(int argc, char* argv[])
{
	try
	{
		COMInitializer ci;
		HRESULT hr;
		SmartCOMPtr<IFileDialog2> fd;

		// Crer une instance COM de IFileDialog2
		hr = ::CoCreateInstance(CLSID_FileSaveDialog,
                          NULL,
                          CLSCTX_INPROC_SERVER,
                          IID_IFileDialog2,
                          (void **)&fd);
		COMHelper::TestOk(hr);

		GUID pl = FOLDERID_PicturesLibrary;
		SmartCOMPtr<IShellItem> item;
		hr = ::SHGetKnownFolderItem(pl,
			KF_FLAG_DEFAULT_PATH, 
			0,
			IID_IShellItem,
			reinterpret_cast<void **>(&item));
		COMHelper::TestOk(hr);
		hr = fd->SetNavigationRoot(&(*item));
		COMHelper::TestOk(hr);
		fd->Show(0);
	}
	catch(COMException ce)
	{
		std::cout << ce.raison() << std::endl;
		return EXIT_FAILURE;
	}
	return EXIT_SUCCESS;
}
